<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" />
  <title>Сб 07 мая 2022 23:03:29 EET Markdown/AsciiMath to HTML (by marked)</title>
  <link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/github-markdown-css/3.0.1/github-markdown.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.4/latest.js?config=AM_CHTML"></script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  asciimath2jax: {
    delimiters: [['$','$']]
  }
});
  </script>
  <script src="https://cdn.jsdelivr.net/npm/marked/marked.min.js"></script>
</head>
<body class="markdown-body">
  <div id="display"></div>
  <script>
    content =
"# Practical course Networking Lab \n\n## Lab1 - Worked on by Aleksei Makarov and Egi Brako\n\n### Exercise 1\n\na) We logged in as user with the following data: login - **ubuntu**, password - **lab**.\n\nb) To setup the networks we used Ethernet cables, plugging them into corresponding interfaces *eth0* on PC\'s.\n\nc) We used the commands `(PC1) $ telnet 10.0.1.12` to start telnet session from *PC1* to *PC2*.\n\n### Exercise 3\n\nIn this exercise we used 3 methods: two via `>`, specifically `ls -l > etcfile_1_ex3` and `ls > etcfile_2_ex3 & tail -f etcfile_2_ex3`. The `tail` command is used to output the end of the file. The `-f`-option is used to output appended data as the file grows. (Taken from `man` page). The 3<sup>rd</sup> is just use of `gedit`. \n\nSee the files `etcfile_1_ex3`, `etcfile_2_ex3`, and `etcfile_3_ex3`.\n\n### Exercise 4\n\na) See the file `dffile_1`\n\nb) See the directories `labdataPC2`, `labdataPC3`, and `labdataPC4`.\n\n### Exercise 5\n\na) The file `/etc/hosts` is contained in the file `ex5`.\n\nb)\n\n1. The file `/etc/hostname` contains the hostname. After changing it, we should also change any occurence of the previous name to the new one in the file `/etc/hosts`. Then we need to reboot the system with `sudo reboot`.\n\n2. To check if the the IPv4-forwarding is enabled check the file `/proc/sys/net/ipv4/ip_forward`. Depending on the value (1/0) we conclude, if the forwarding is enabled or not.\n\n3. The  network interface configuration files can be found at `/etc/network/interfaces`.\n\n### Exercise 6\n\n1. See the files `ping2pc1` and `ping2pc2` for corresponding pings to *PC1* and *PC2*. See the file `ping2loopback` to look at the output of ping from *PC1* to its loopback interface. \n\n2. The loopback interface is a visual network interface through which network applications can communicate within the same device. It is implemented entirely within the operating system and passes no packets to any network interface controller. In opposite, the local Ethernet interface refers to a circuit card installed in device as a network client. That means, that the `ping 127.0.0.1` (commonly used loopback IP address) will be faster than `ping 10.0.1.11` from *PC1* to himself. This happens because the first signal will be delivered immediately, whereas the second will pass through the switch, then get rerouted to the source. \n\n### Exercise 7\n\na) See the files `ping_ex7_1` and `tcpdump_ex7_2`.\n\n<br>\n\nIn the first file (`ping_ex7_1`) we can see a few fields in the packets. Firstly is *icmp_seq=1*. This is simply the sequence number that is given to this packet by the Internet Control Message Protocol.\n\nSecond is *ttl=64*. This is the remaining time to live of the current packet. It gets decremented at every hop, and once it reaches 0, the packet is dropped.\n\nThird is *time=0.370ms*. This is the total time it took to send and receive the echo packet including delay time. So in other words, the round trip time\n\n<br><br>\n\nIn the second file (`tcpdump_ex7_2`) We see more or less the same fields.\n\n*16:20:59.923248* is the exact time of the packet.\n\n*IP* is the network layer protocol, in this case the Internet Protocol.\n\n*10.0.1.11* is the source IP address.\n\n*10.0.1.12* is the destination IP address.\n\n*ICMP echo request* is the type of packet, in this case it\'s the source requesting the destination for an echo response.\n\n*id 4266* is the identification number of the packet.\n\n*seq 1* is the sequence number of the packet\n\n*length 64* is the size of the packet, in this case 64 bytes.\n\n\n\n<br>\n\nb) See the file *tcpdump_ex7_b*. In our case only *PC2* responded to broadcast ping.\n\n### Notes\n\nThe times on the packets are wrong as the times on the computers were wrong.\n\n\n\n\n";async function displayer(){ // MathJax is not usable right after import, so we just wait and check until it is
    // markdown and asciimath do not naturally cooperate - we have to extract the asciimath parts and insert them later
	// we have to differentiate though: if the asciimath parts were in code areas (i.e. pre-tags), then we do not want to convert them
	//
	// we note that asciimath and pre-tags can not be interleaved in any sensible way, so we ignore that case
	var mathCounter = 0;
	var mathContents = [];
	while(((content.match(/\$/g) || []).length >= 2)){ // while there is still possible AsciiMath
		var start = content.indexOf("$");
		var end = content.indexOf("$", start + 1);
		mathContents.push(content.substring(start, end + 1));
		content = content.substring(0, start) + "<span id = 'ASCIIMATHREINSERTIONPLACEHOLDER" + mathCounter + "'></span>" + content.substring(end + 1); // it would be nicer to do without this, but what about sorting out hBsigns inside backtick-maths, or the other way around?
		mathCounter++;
	}

	while(typeof(MathJax) == "undefined"){ // we need MathJax in the next step, and may have to wait until it is initialized (does not happen on immediately import (even though it is not async))
		await new Promise(resolve => setTimeout(resolve, 100));
	}
	document.getElementById("display").innerHTML = marked.parse(content);
	for(var mathNumber = 0; mathNumber < mathCounter; mathNumber++){ // here we go through all parent elements of any contained tag and check if they are <pre>-elements if one is, then this is code ()
		var edEl = document.getElementById('ASCIIMATHREINSERTIONPLACEHOLDER' + mathNumber);
		if(edEl == null){ // the tag has fallen into a code area, turning it into plain text
		    document.body.outerHTML = document.body.outerHTML.replace("&lt;span id = 'ASCIIMATHREINSERTIONPLACEHOLDER" + mathNumber + "'&gt;&lt;/span&gt;", mathContents[mathNumber])
		}
		else{
			edEl.innerHTML = mathContents[mathNumber];
			MathJax.Hub.Typeset(edEl);
		}
	}
  };

  displayer();
  </script>
</body>
</html>

</body>
</html>
